#ifndef _BAND_H
#define _BAND_H

// render graphics band-at-a-time so
// * it can easily be sent to the printer
// * we don't need to allocate a full image-sized buffer
#define kByteBandWidth 128
#define kByteBandHeight  8
class tByteBand
{
public:
  enum tBandLayout 
  { 
    eHorizontalBytes, 
    eVerticalBytes 
  };

  struct tPixelPos 
  {
    byte m_iMask;
    int  m_iIndex;
    int m_iRow;
    int m_iCol;
  };

  byte* Data();
  byte Band();
  void Init(byte Number, tBandLayout Layout);
  bool GetPixel(int Row, int Col, tPixelPos& Pos);
  bool NextPixelRight(tPixelPos& Pos);
  bool NextPixelDown(tPixelPos& Pos);
  void SetPixel(const tPixelPos& Pos, bool Set);
  void InvertPixel(const tPixelPos& Pos);
  void SetPixel(int Row, int Col, bool Set);
  bool IsPixelSet(tPixelPos& Pos);
  void Fill(byte Value);
  void Dump();
  
private:
  byte m_pOutputBand[kByteBandWidth];
  tBandLayout m_iLayout;
  byte m_iBandNumber;
};

extern tByteBand band;

#endif
