#include <Arduino.h>
#include "RTC.h"
#include "CFG.h"

Config cfg;

Config::Config()
{
  Defaults();
}

void Config::Defaults()
{
  m_WeekOn = PackTime(22, 2);
  m_WeekOff = PackTime(6, 3);
  m_WeekendOn = PackTime(22, 2);
  m_WeekendOff = PackTime(10,  2);
  m_AutoOn = 1;
  m_iThresholdPercent = 20;  // 20%
  m_iBaseReadingBy4 = 32;  // eigth of range 0..1023
}

void Config::Load()
{
  int Idx = 8;
  m_WeekOn = rtc.ReadByte(Idx++);
  m_WeekOff = rtc.ReadByte(Idx++);
  m_WeekendOn = rtc.ReadByte(Idx++);
  m_WeekendOff = rtc.ReadByte(Idx++);
  m_AutoOn = rtc.ReadByte(Idx++);
  m_iThresholdPercent = rtc.ReadByte(Idx++);
  m_iBaseReadingBy4 = rtc.ReadByte(Idx++);
}

void Config::Save()
{
  int Idx = 8;
  rtc.WriteByte(Idx++, m_WeekOn);
  rtc.WriteByte(Idx++, m_WeekOff);
  rtc.WriteByte(Idx++, m_WeekendOn);
  rtc.WriteByte(Idx++, m_WeekendOff);
  rtc.WriteByte(Idx++, m_AutoOn);
  rtc.WriteByte(Idx++, m_iThresholdPercent);
  rtc.WriteByte(Idx++, m_iBaseReadingBy4);
}

void Config::UnPackTime(byte Packed, byte& Hour, byte& Quarter)
{
  Hour = (Packed >> 2) % 24;
  Quarter = (Packed & 0x03);
}
 
byte Config::PackTime(byte Hour, byte Quarter)
{
  return (((Hour % 24) << 2) | (Quarter % 4)); 
}
