#ifndef _MENU_H
#define _MENU_H

#include "Button.h"

class Menu
{
  public:
    enum tMenuItems
    {
      eNULL_ITEM,
      eStartMenu,
      eViewMenu,
      ePrintMenu,
      eConfigMenu,
    
      eViewLastNightMenu,
      eViewAllMenu,
      eViewTestMenu,
      eBackMenu,
      eSetMenu,
    
      ePrintLastNightMenu,
      ePrintAllMenu,
      ePrintTestMenu,
    
      eConfigTimeMenu,
      eConfigDateMenu,
      eConfigAutoMenu,
    
      eCurrentHourItem,
      eCurrentMinuteItem,
      eCurrentDayItem,
    
      eCurrentDateItem,
      eCurrentMonthItem,
      eCurrentYearItem,
    
      eAutoWeekdayMenu,
      eAutoWeekendMenu,
    
      eAutoOnItem,
      eAutoWeekdayOnItem,
      eAutoWeekdayOffItem,
    
      eAutoWeekendOnItem,
      eAutoWeekendOffItem,
      
      eConfigSettingsMenu,
      eSettingBaseReading,
      eSettingThresholdPercent,
    
      eREDRAW,
      eTIME_CHECK,
      eGREEN_RED,
      eLAST_ITEM
    };
    
    Menu();
    void Init();
    tMenuItems DoMainMenu();

    enum tBtn {eNone, eRed, eGreen, eTimeCheck, eGreenWhileRedDown, eRedraw};
    tBtn WaitForButtonOrTimeout(long TimeoutMS = 0);
private:
  tBtn WaitForButton(unsigned long StartMS, bool CheckTime);
  void IncrementItem(byte& Item, int Min, int Max, bool Increment, int Step);
  void LoadString(tMenuItems Item, char* Buffer);
  char* StdItem(byte& Value, int Min, int Max, bool IncrementFirst, char* Buffer, char Lead, int Step = 1);
  char* AutoItem(byte& Value, bool IncrementFirst, char* Buffer, byte Min, byte Max);
  char* AutoOnItem(byte& Value, bool IncrementFirst, char* Buffer);
  bool GetItem(tMenuItems Item, char* LineBuffer, bool IncrementFirst);
  void SelectItem(int Line);
  tMenuItems DoMenu(tMenuItems M0, tMenuItems M1, tMenuItems M2, tMenuItems M3, int& SelectedLine);
  void DoSubMenu(tMenuItems M0, tMenuItems M1, tMenuItems M2, tMenuItems M3);
  
  void DoViewMenu();
  void DoPrintMenu();
  void DoConfigMenu();
  void DoSettingsMenu();
  void DoAutoMenu();
  
  int m_iCurrentlyInvertedLine;
  static char* m_pItemStrings[];
  static prog_uchar m_pCustomPointerChar[];
  unsigned long m_iButtonTimeMS;
};

extern Menu menu;
#endif
